#line 6 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "gfx-1_4.h"
#include "ptrbuf.h"
#include "strbuf.h"
#include "expr.h"
#include "widget.h"
#include "main.h"
#include "edit_widget.h"
#include "show_resources.h"

#define PAD 10

enum { WI_OK= GFXEV_LAST+1, WI_CANCEL, WI_Btop, WI_Bbot, WI_Blef, WI_Brig,
                                 WI_Bwid, WI_Bhei, WI_LAST };

#line 31 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"
static int eLabel;

#line 195 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"
#define EDITx 300
#define EDITy 200
#define EDITw 400
#define EDITh 400

static int efX, efY;

#line 30 "edit_widget.c"

static void eError(char *msg);
static int check_three(int *lab, int p1,int p2,int p3, char *msg);
static int check_expr(int ent,char **Rstr, expr_t **Rexpr);
static void free_null_set(void *a, void *V, void (*f)(void*));
static void free_expr(void *a);
static int getevent(gfx_event_t *event);
static int check_uniq(Uscreen_t *screen,Uwidget_t *W,char *str);
static int ebegin();
static int efield(char *label,char *str,int baction);
static int ebutton(char *label, int action);
static void choose_var(Uscreen_t *S, int wid, int kind);
static int attrib_field(Uwidget_t *W, field_t *f,int *Rcount, int *Rbut);
static void apply_field(Uwidget_t *W, field_t *ref, int ent);
static field_t *find_widget_field(Uwidget_t *W,char *name);
#line 124 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

static void eError(char *msg)
{
  gfx_label_set_text(GFX_UPDATE,eLabel,msg);
}

static int check_three(int *lab, int p1,int p2,int p3, char *msg)
{
  char *s1,*s2,*s3;
  int E;
  s1= gfx_text_entry_get(lab[p1]);
  s2= gfx_text_entry_get(lab[p2]);
  s3= gfx_text_entry_get(lab[p3]);
  if (s1&&s2&&s3&&s1[0]&&s2[0]&&s3[0]) E= 1; else E= 0;
  free_null_set(&s1, NULL, free);
  free_null_set(&s2, NULL, free);
  free_null_set(&s3, NULL, free);
  if (E) { eError(msg); gfx_focus(lab[p1]); }
  return E;
}

static int check_expr(int ent,char **Rstr, expr_t **Rexpr)
{
  char *S,*M;
  expr_t* E;
  S= gfx_text_entry_get(ent);
  if (!S || !S[0]) { *Rstr= NULL; *Rexpr= NULL; return 0; } // it's cool 
  E= xpp_run(xpp,S);
  if (!E) { M= "Invalid expr"; goto fail; }
  if (E->op==XPP_ERROR) { M= E->data; goto fail; } 

  *Rstr= S;
  *Rexpr= E;
  return 0;

fail:
  eError(M); 
  free(S); 
  if (E) xpp_free_expr(E); 
  gfx_focus(ent); 
  return 1;
}

static void free_null_set(void *a, void *V, void (*f)(void*))
{
  void **P;
  P= a;
  if (*P) (*f)(*P);
  *P= V;
}

static void free_expr(void *a)
{
  xpp_free_expr(a);
}

static int getevent(gfx_event_t *event)
{
  while(1)
   if (gfx_event(NULL,event)) return event->type;
}

static int check_uniq(Uscreen_t *screen,Uwidget_t *W,char *str)
{
  Uwidget_t *K;
  for(K=screen->widgets;K;K=K->next)
   if (K!=W && !strcmp(K->ident, str)) return 1;
  return 0;
}

#line 203 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

static int ebegin()
{
  int scr;
  scr= gfx_push_screen();
  gfx_fill_rect(0, EDITx, EDITy, EDITw, EDITh, 0xededed);
  gfx_draw_rect(0, EDITx-1, EDITy-1, EDITw-1, EDITh-1, 0x00);
  efY= PAD;
  efX= PAD;
  return scr;
}

static int efield(char *label,char *str,int baction)
{
  int R;
  gfx_print(0,1,0x00, 0xededed, EDITx+PAD, EDITy+efY+4, label, NULL,NULL);
  R= gfx_text_entry( EDITx+PAD+ 60, EDITy+efY, 130, 30, str);
  gfx_show(R,1);
  if (baction!=-1)
    gfx_button(GFX_UPDATE, EDITx+PAD+60+130+PAD, EDITy+efY, 
                         60,30, "Var",baction);
  efY+= 30+PAD;
  return R;
}

static int ebutton(char *label, int action)
{
  int R;
  R= gfx_button(GFX_UPDATE, EDITx+efX, EDITy+efY, 80, 30, label, action);
  efX+= 80+PAD;
  return R;
}

static void choose_var(Uscreen_t *S, int wid, int kind)
{
  int n,R;
  Uvar_t *V;
  n= 0;
  for(V=S->vars;V;V=V->next) if (V->vartype==kind) n++;

  if (!n) return ;
  TUPiis_t *ent;
  ent= malloc(sizeof(*ent)*n);
  n= 0;
  for(V=S->vars;V;V=V->next) 
  {
    if (V->vartype==kind)
    { ent[n].iv1= n; ent[n].iv2= 0; ent[n].sv= V->ident; n++; }
  }
  R= gfx_fwmenu(1,n,ent);
  if (R>=0) 
    gfx_text_entry_set(GFX_UPDATE, wid, ent[R].sv);
  free(ent);
}

#line 330 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

static int attrib_field(Uwidget_t *W, field_t *f,int *Rcount, int *Rbut)
{
  gfx_print(GFX_UPDATE,1,0, 0xededed, 
            EDITx+efX, EDITy+efY+4, f->name, NULL, NULL);

  int R= gfx_text_entry(EDITx+efX+80, EDITy+efY, 200,30,  "");
  field_t *FF;
  FF= find_widget_field(W,f->name);
  if (FF)
      gfx_text_entry_set(0, R, FF->data);
  efY+= 30+PAD;
  gfx_show(R,1);

  if (f->type==TYP_COLORIMG)
  {
    gfx_button(GFX_UPDATE,EDITx+efX+80+200+10,EDITy+efY,60,30,"...",*Rcount);
    *Rbut= *Rcount;
  } else *Rbut= -1;
  (*Rcount)++;

  return R;
}

static void apply_field(Uwidget_t *W, field_t *ref, int ent)
{
  char *S;
  field_t *F;
  S= gfx_text_entry_get(ent);
  F= find_widget_field(W, ref->name);
  if (F)
  {
    F->data= S;
    return ;
  }
  if (S[0])
  {
    F= malloc(sizeof(*F));
    F->name= strdup(ref->name);
    F->type= ref->type;
    F->data= S;
    F->next= W->fields;
    W->fields= F;
  }
}

static field_t *find_widget_field(Uwidget_t *W,char *name)
{
  field_t *F;
  for(F=W->fields;F;F=F->next)
    if (!strcmp(F->name,name)) return F;
  return NULL;
}

#line 34 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

void edit_widgetpos(Uscreen_t *screen,Uwidget_t *W,int inifoc)
{
  edit_pos(screen, &W->ident, &W->pos,inifoc, W);
}

void edit_pos(Uscreen_t *screen,char** Rident,Upos_t *opos,
                 int inifoc,Uwidget_t* refw)
{
  int scr;
  int eIDENT;
  int i;
  char *fnames[]= { "Top", "Bottom", "Left", "Right", "Width", "Height" };
  char *ident;
  int ePOS[6];
  char *pos_str[6];
  expr_t *pos_expr[6];
  scr= ebegin();

  eIDENT= efield("Ident", *Rident,-1);

  for(i=0;i<6;i++) ePOS[i]= efield(fnames[i], opos->S[i], WI_Btop+i);

  ebutton("OK", WI_OK);
  ebutton("Cancel", WI_CANCEL);

  eLabel= gfx_label(GFX_UPDATE,1,0x00,0xededed,
                     EDITx+PAD, EDITy+EDITh-PAD-30, EDITw-PAD-PAD, 30,"");

  if (inifoc>=0 && inifoc<6) gfx_focus(ePOS[inifoc]);
  else gfx_focus(eIDENT);

again:
  gfx_update_all();

  gfx_event_t event;
  while(1)
   switch(getevent(&event))
   {
   case GFXEV_QUIT:
   case WI_CANCEL:  goto done;
   case WI_OK: goto apply;
   case WI_Btop: choose_var(screen,ePOS[wTOP], VAR_Y); break;
   case WI_Bbot: choose_var(screen,ePOS[wBOT], VAR_Y); break;
   case WI_Blef: choose_var(screen,ePOS[wLEF], VAR_X); break;
   case WI_Brig: choose_var(screen,ePOS[wRIG], VAR_X); break;
   case WI_Bwid: choose_var(screen,ePOS[wWID], VAR_W); break;
   case WI_Bhei: choose_var(screen,ePOS[wHEI], VAR_H); break;
   }
  
done:
   gfx_restore_screen(scr);
   return ;

apply:
   ident= gfx_text_entry_get(eIDENT);
   if (!ident || !ident[0])
   { 
      eError("Invalid identifier"); 
      gfx_focus(eIDENT);
      goto again;
   }
   if (refw && check_uniq(screen,refw,ident))
   {
     eError("A widget with the same name already exists.");
     gfx_focus(eIDENT); 
     goto again;
   }

   if (check_three(ePOS, wTOP, wBOT, wHEI, 
                 "Choose two of three: Top, Bottom, Height"))
      goto again;
   
   if (check_three(ePOS, wLEF, wRIG, wWID,
                  "Choose two of three: Left, Right, Width"))
      goto again;
   
   for(i=0;i<6;i++)
      if (check_expr(ePOS[i], &pos_str[i], &pos_expr[i])) goto again;

   free_null_set( Rident, ident, free);
   for(i=0;i<6;i++)
   {
      free_null_set(&opos->S[i], pos_str[i], free);
      free_null_set(&opos->E[i], pos_expr[i], free_expr);
   }
   goto done;
}

#line 265 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

void edit_attribs(Uwidget_t *W)
{
  int i,D;
  char *sv;
  int scr;
#define NATTR 5 
  int af[NATTR];
  int ab[NATTR];
  int bcount;
  scr= ebegin();

  bcount= WI_LAST;
  for(i=0;i<NATTR;i++)
  {
    if (i>=W->klass->nfields) break;
    af[i]= attrib_field(W, W->klass->fields+i, &bcount, &ab[i]);
  }

  if (i>0) gfx_focus(af[0]);

  efY= EDITh-PAD-30;

  ebutton("OK", WI_OK);
  ebutton("Cancel", WI_CANCEL);
  
  gfx_update_all();
  while(1)
  {
    gfx_event_t event;
    if (!gfx_event(NULL,&event)) continue;
    switch(event.type)
    {
    case GFXEV_QUIT: 
    case WI_CANCEL: goto done;
    case WI_OK: goto apply;
    default:
        D= event.type-WI_LAST;
        if (D<0 || D>=NATTR || ab[D]==-1) continue;
        if (D>=W->klass->nfields) continue;
        switch(W->klass->fields[D].type)
        {
        case TYP_COLORIMG:
           sv= choose_color_image();
           if (sv) gfx_text_entry_set(GFX_UPDATE,af[D],sv);
           break;
        }
        break;
    }
  }
done:
  gfx_restore_screen(scr);
  return ;
apply:
  for(i=0;i<NATTR;i++)
  {
     if (i>=W->klass->nfields) break;
     apply_field(W, W->klass->fields+i, af[i]);
  }
  if (!strcmp(W->klass->ident,"Panel"))
    make_panel_subs(W);
  goto done;
}

#line 29 "/home/dodo/tmp/GG/gfx-2.2/src/edit_widget.u"

