#line 16 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>
#include "gfx-1_4.h"
#include "ptrbuf.h"
#include "strbuf.h"
#include "expr.h"
#include "widget.h"
#include "main.h"
#include "edit_widget.h"
#include "show_vars.h"
#include "show_resources.h"
#include "library.h"

#define DISPW 1000
#define DISPH 800
#define BUT_W 70
#define BUT_H 26
#define PAD 8

xpp_t *xpp;

enum { WI_WIDGETNEW= GFXEV_LAST+1, WI_WIDGETEDIT, WI_WIDGETPOS, WI_WIDGETDEL,
       WI_OK, WI_CANCEL, WI_NEWSCR, WI_SELSCR, WI_EDISCR,
       WI_EVAL, WI_VARS, WI_LOAD, WI_SAVE, WI_LAYOUT, WI_GEN, WI_RESOURCE};

#line 8 "/home/dodo/tmp/GG/gfx-2.2/src/eval.u"

typedef struct
{
  char *name;
  int *sto;
} known_t;

#line 6 "/home/dodo/tmp/GG/gfx-2.2/src/save.u"
#define WORD_STR(XX) #XX
#define WORD_KEY(XX) KEY_##XX
#define KWORD WORD_KEY

#define FOT_WORDS \
   WORD(VAR) \
      WORD(VALUE) WORD(TYPE) \
   WORD(WIDGET) \
      WORD(KLASS) WORD(FNAME) WORD(FVALUE) WORD(SUBS) WORD(ENDSUBS) \
      WORD(p0) WORD(p1) WORD(p2) WORD(p3) WORD(p4) WORD(p5) \
      WORD(DX) WORD(DY) WORD(DW) WORD(DH) \
   WORD(SCREEN) \
      WORD(Sp0) WORD(Sp1) WORD(Sp2) WORD(Sp3) WORD(Sp4) WORD(Sp5) \
   WORD(ENDSCREEN)  \
   WORD(RESOURCE) \
     WORD(RTYPE) WORD(RLENGTH) WORD(RDATA) WORD(ENDRESOURCE) \
   WORD(END)

enum fot {
#define WORD(X) WORD_KEY(X),
FOT_WORDS
#undef WORD
};

#line 63 "main.c"

static int button(char *text,int action);
static void make_buttons();
static Uwidget_t* make_widget(Uklass_t *klass,int x1,int y1,int x2,int y2);
static void draw_widget(Uwidget_t *W);
static Uwidget_t *find_widget_bydpos(int x,int y);
static Uwidget_t *find_widget_in_screen(Uscreen_t *S,char *id);
static Uwidget_t *find_widget(char *id);
static int make_diag(int x,int y,int w,int h);
static void evalscr();
static void draw_everything();
 
static void new_screen();
static Uscreen_t *create_screen();
static void select_screen();
static void edit_screen(Uscreen_t *S);
static Uscreen_t** get_all_screens(int *Rn);
static void get_sub_screens(ptrbuf_t *B, Uscreen_t *S);
static void free_widget(Uwidget_t *w);
static void get_widget_layout_unknowns
   (Uscreen_t *S,unknown_t ***Runk,size_t *Rnunk);
static void copy_fixed_knowns(size_t nunk);
static char *eval_widget_layout(Uscreen_t *S, size_t *Rnunk, unknown_t ***Runk);
static char *eval_assignments(strbuf_t *Bcode,size_t *Rnunk, unknown_t **unk);
static int eval_expr(char *target, expr_t *E, strbuf_t *buffer);
static int eval_sub(expr_t *E, strbuf_t *buffer);
static int evalbinop(expr_t *E, strbuf_t *buffer, char *op);
static void makeref
  (ptrbuf_t *B, Uwidget_t *W, int tgt, int s1, char *op, int s2) ;
static int evalpreop(expr_t *E, strbuf_t *buffer, char *op);
static void evaldis_coords(Uscreen_t *S,int sw,int sh);
  
static int evaldis_expr(int *STO, expr_t *E);
static int evaldis_sub(expr_t *E, double *RV);
static int evaldis_binop(expr_t *E, double *RV, double (*f)(double,double));
static int evaldis_preop(expr_t *E, double *RV, double (*f)(double));
static double opADD(double A,double B) ;
static double opSUB(double A,double B) ;
static double opMUL(double A,double B) ;
static double opDIV(double A,double B) ;
static double opMOD(double A,double B) ;
static double opNEG(double A) ;
static char *eval_screen_dim(Uscreen_t *S);
static void free_unknown(unknown_t *U);
static void makeSref
  (ptrbuf_t *B, Uscreen_t *S, int tgt, int s1, char *op, int s2) ;
static void safield_s(FILE *f, char *name, char *value);
static void save_screen(Uscreen_t *S,FILE *f);
static void save_resource(resource_t *R,FILE *f);
static void save_file();
static void fstr(FILE *f, char *str, char *sfx);
static int load_file(Uscreen_t **Rscr, resource_t **Rres);
static enum fot command(char *g,char **Ra);
static int getcmdline(char *g,int sz,FILE *f);
static Uscreen_t *load_screen(char *ident,FILE *f);
static resource_t *load_resource(char *ident,FILE *f);
static char *Sarg(char *V);
static int Iarg(char *V);
static int spfx(char *str, char **PF,char **R);
static char *dotless_name(char *str, char *pfx);
static char *widget_layout_fname(Uscreen_t *scr);
static char *screen_layout_fname(Uscreen_t *scr);
 
static void gen_widget_layout(Uscreen_t *scr,FILE* f);
static void gen_screen_dim(Uscreen_t *scr, FILE *f);
static void gen_widget_names(FILE *f);
static void declare_widget_list(Uwidget_t **WL, int n, FILE *f);
static Uwidget_t** get_widget_list_breadthfirst(Uscreen_t *scr,int *Rn);
static void gen_screen_func(Uscreen_t *scr,FILE *f,int mode);
static char *replace_suffix(char *str,char *sfx);
static void gen_screen();
static void Gcreate_widget(Uwidget_t *W,FILE *f);
static void Ginitialmove_widget(Uwidget_t *W,FILE *f,int N);
static void Gshow_widget(Uwidget_t *W,FILE *f);
static void gen_resources(FILE *f);
static void gen_colorimg_resource(FILE *f,resource_t *R);
static Uklass_t *choose_klass();
static void Kcreate_button(Uwidget_t *W, FILE *f);
static void Kcreate_toggle(Uwidget_t *W, FILE *f);
static char *get_field(Uwidget_t *W, char *name, char *def);
static char *nustr(char *x);
static char *Cstr(char *x);
static void Kcreate_label(Uwidget_t *W, FILE *f);
static void Kcreate_radio(Uwidget_t *W, FILE *f);
static void Kcreate_checkbox(Uwidget_t *W, FILE *f);
static void Kcreate_scrollbar(Uwidget_t *W,FILE *f);
static void Kcreate_panel(Uwidget_t *W, FILE *f);
static void Kcreate_dropdown(Uwidget_t *W,FILE *f);
static void Kcreate_list(Uwidget_t *W,FILE *f);
static void Kcreate_pixgrid(Uwidget_t *W,FILE *f);
static void Kcreate_textentry(Uwidget_t *W,FILE *f);
static void Kcreate_canvas(Uwidget_t *W,FILE *f);
#line 161 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

static Uscreen_t *screen,*screens;
resource_t *resources;
static int but_x=PAD,but_y=PAD;
static int area_x, area_y, area_w, area_h;

#line 290 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"
#define EVx 300
#define EVy 200
#define EVw 400
#define EVh 400

#line 16 "/home/dodo/tmp/GG/gfx-2.2/src/eval.u"

static known_t *kno; static size_t nkno;

static int f_wid= 800, f_hei= 600;
static int fscw= 12, fsch= 12;
static known_t fixed[]=
{ 
  { "WIDTH", &f_wid }, {"HEIGHT", &f_hei},
  { "gui_scrollbar_width", &fscw}, 
  { "gui_scrollbar_height", &fsch}, 
};
  static char *Cnames[6]= 
        { "top", "bottom", "left", "right", "width", "height" };
static int nfixed= 4;

#line 4 "/home/dodo/tmp/GG/gfx-2.2/src/klasses.u"

static field_t fields_button[]= 
 {
   { "text", TYP_STR, NULL },
   { "iconpos", TYP_INT, "T" },
   { "icon", TYP_COLORIMG, NULL },
 };
 
static Uklass_t klass_button= { 
   "Button", 3, fields_button, 
   Kcreate_button };

static field_t fields_toggle[]=
 {
   { "text", TYP_STR, NULL },
   { "iconpos", TYP_INT, "T" },
   { "icon", TYP_COLORIMG, NULL },
 };
static Uklass_t klass_toggle= {
   "Toggle", 3, fields_toggle,
   Kcreate_toggle };

static field_t fields_label[]=
 {
   { "text", TYP_STR, NULL },
   { "fg",   TYP_INT, "0x000000" },
   { "bg",   TYP_INT, "0xededed" },
   { "font", TYP_INT, "1" },
   { "just", TYP_INT, "C" },
 };

static Uklass_t klass_label= {
   "Label", 5, fields_label, 
   Kcreate_label };

static field_t fields_radio[]= 
 {
   { "text", TYP_STR, NULL },
   { "group", TYP_INT, "-1"},
 };

static Uklass_t klass_radio= {
  "Radio", 2, fields_radio,
  Kcreate_radio };

static Uklass_t klass_canvas=
{
  "Canvas", 0, NULL, Kcreate_canvas,
};

static field_t fields_checkbox[]= 
 {
   { "text", TYP_STR, NULL },
 };

static Uklass_t klass_checkbox= {
  "CheckBox", 1, fields_checkbox,
  Kcreate_checkbox };

static field_t fields_panel[]= 
 {
   { "n_subs", TYP_INT, "2" }
 };

static Uklass_t klass_panel = {
  "Panel", 1, fields_panel,
  Kcreate_panel };

static field_t fields_scrollbar[]=
 {
   { "vertical", TYP_INT, "0" },
   { "init_start", TYP_INT, "0.0" },
   { "init_end", TYP_INT, "1.0" },
   { "init_step", TYP_INT, "0.1" },
 };

static Uklass_t klass_scrollbar=
 { "ScrollBar", 4, fields_scrollbar ,
   Kcreate_scrollbar };

static Uklass_t klass_dropdown=
 { "DropDown", 0, NULL ,
   Kcreate_dropdown };

static Uklass_t klass_list=
 { "List", 0, NULL ,
   Kcreate_list };

static Uklass_t klass_pixgrid=
 { "PixGrid", 0, NULL ,
   Kcreate_pixgrid };

static field_t fields_textentry[]=
 {
   { "text", TYP_STR, NULL },
 };

static Uklass_t klass_textentry= {
   "TextEntry", 1, fields_textentry, 
   Kcreate_textentry };



static Uklass_t *klasses[]=
{ &klass_button,
  &klass_canvas,
  &klass_checkbox,
  &klass_dropdown,
  &klass_label,
  &klass_list,
  &klass_panel,
  &klass_pixgrid,
  &klass_radio,
  &klass_scrollbar,
  &klass_textentry,
  &klass_toggle,
};

static TUPiis_t *klass_menu;

#line 168 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

static int button(char *text,int action)
{
  int R;
  if (but_x+BUT_W+PAD>DISPW)
  {
    but_x= PAD;
    but_y+= PAD+BUT_H;
  }
  R= gfx_button(GFX_UPDATE, but_x,but_y,BUT_W,BUT_H,text,action);
  but_x+= BUT_W+PAD;
  return R;
}

static void make_buttons()
{
  button("New", WI_WIDGETNEW);
  button("Edit", WI_WIDGETEDIT);
  button("Pos", WI_WIDGETPOS);
  button("Del", WI_WIDGETDEL);
  button("Eval", WI_EVAL);
  button("Layout", WI_LAYOUT);
  button("Vars", WI_VARS);
  button("Save", WI_SAVE);
  button("Load", WI_LOAD);
  button("Gen", WI_GEN);
  button("S-New", WI_NEWSCR);
  button("S-Sel", WI_SELSCR);
  button("S-Edit", WI_EDISCR);
  button("Reso", WI_RESOURCE);
  area_x= PAD;
  area_y= but_y + BUT_H + PAD;
  area_w= DISPW - area_x - gui_scrollbar_width;
  area_h= DISPH - area_y - gui_scrollbar_height;
}



#line 207 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

static Uwidget_t* make_widget(Uklass_t *klass,int x1,int y1,int x2,int y2)
{
  Uwidget_t *W;
  char buf[200];
  static int LW;
  W= calloc(1,sizeof(*W));
  sprintf(buf,"W%d",LW++);
  W->ident= strdup(buf);
  W->klass= klass;
  if (!strcmp(klass->ident,"ScrollBar"))
  {
    W->pos.S[wWID]= strdup("gui_scrollbar_width");
    W->pos.S[wHEI]= strdup("gui_scrollbar_height");
    W->pos.E[wWID]= xpp_run(xpp,W->pos.S[wWID]);
    W->pos.E[wHEI]= xpp_run(xpp,W->pos.S[wHEI]);
  }
  W->pos.Dx= x1;
  W->pos.Dy= y1;
  W->pos.Dw= x2-x1;
  W->pos.Dh= y2-y1;
  W->next= screen->widgets;
  screen->widgets= W;
  return W;
}

static void draw_widget(Uwidget_t *W)
{
  gfx_fill_rect(0,area_x+W->pos.Dx, area_y+W->pos.Dy,
                  W->pos.Dw, W->pos.Dh, 0xffFFff);
  gfx_draw_rect(0,area_x+W->pos.Dx, area_y+W->pos.Dy,
                  W->pos.Dw-1, W->pos.Dh-1, 0x00);
  gfx_print_fit("C.","C.",
     area_x+W->pos.Dx, area_y+W->pos.Dy, W->pos.Dw-1, W->pos.Dh-1, 
     1, 0,0x00,0xededed, W->ident);
  gfx_update(W->pos.Dx, W->pos.Dy, W->pos.Dw, W->pos.Dh);
}

static Uwidget_t *find_widget_bydpos(int x,int y)
{
  Uwidget_t *W;
  for(W=screen->widgets;W;W=W->next)
    if (W->pos.Dx<=x && W->pos.Dy<=y && (W->pos.Dx+W->pos.Dw)>x
        && (W->pos.Dy+W->pos.Dh)>y) return W;
  return NULL;
}

static Uwidget_t *find_widget_in_screen(Uscreen_t *S,char *id)
{
  Uwidget_t *W,*R;
  int i;
  if (!S) return NULL;
  for(W=S->widgets;W;W=W->next)
  {
    if (!strcmp(W->ident,id)) return W;
    for(i=0;i<W->n_subs;i++)
      if ((R=find_widget_in_screen(W->subs[i],id)))
        return R;
  }
  return NULL;
}

static Uwidget_t *find_widget(char *id)
{
  Uwidget_t *W;
  Uscreen_t *S;
  for(S=screens;S;S=S->next)
    if ((W= find_widget_in_screen(S, id)))
      return W;
  return NULL;
}

static int make_diag(int x,int y,int w,int h)
{
  int scr;
  scr= gfx_push_screen();

  gfx_fill_rect(0,x,y,w,h,0xededed);
  gfx_draw_rect(0,x-1,y-1,w+2,h+2,0x00);
  return scr;
}

#line 296 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

static void evalscr()
{
  char *R;
  size_t nunk;
  unknown_t **unk,*U;
  int scr,i,Z;
  int lER;

  R= eval_widget_layout(screen, &nunk, &unk);
  // printf("code to evalute:\n%s",R);
  if (R) free(R);
  scr= make_diag(EVx,EVy,EVw, EVh);

  lER= gfx_list(0,EVx+PAD,EVy+PAD,EVw-PAD-PAD, EVh-PAD-PAD-BUT_H-PAD, WI_EVAL);
  gfx_button(GFX_UPDATE, EVx+(EVw-BUT_W)/2,
              EVy+EVh-PAD-BUT_H, BUT_W, BUT_H, "OK", WI_OK);

  if (nunk)
  {
    gfx_list_insert(lER,-1, "Following could not be computed:",
                            (void*) -1, NULL, 0,0);
    for(i=0;i<nunk;i++)
    {
      char buf[200];
      snprintf(buf, sizeof(buf), "  %s = %s", unk[i]->target, unk[i]->str);
      buf[sizeof(buf)-1]= 0;
      gfx_list_insert(lER,-1, strdup(buf), (void*) (size_t) i, NULL, 0,0);
    }
  }
  else
  {
    gfx_list_insert(lER,-1, "Success", (void*) -1, NULL, 0,0);
  }
  gfx_show(lER,1);
  gfx_update_all();

  while(1)
  {
   gfx_event_t event;
   if (!gfx_event(NULL,&event)) continue;
   switch(event.type)
   {
   case WI_EVAL: 
     Z= (int) (size_t) event.usr; 
     if (Z<0 || Z>=nunk || !unk[Z]) continue;
     gfx_list_delete(lER, event.key, 1);
     U= unk[Z];
     unk[Z]= NULL;
     if (U->source=='V') { show_vars(screen, U->ptr); }
     if (U->source=='W') { edit_widgetpos(screen, U->ptr, U->subsource); }
     free(U);
     break;
   case WI_OK:
   case GFXEV_QUIT: goto done;
   }
  }
  

done:
  for(i=0;i<nunk;i++) if (unk[i]) free(unk[i]); // FIXME: free the fields also
  if (unk) free(unk);
  gfx_restore_screen(scr);
}

static void draw_everything()
{
  Uwidget_t *W;
  gfx_fill_rect(0,area_x,area_y,area_w,area_h, 0xffFFff); 
  for(W=screen->widgets;W;W=W->next) 
    draw_widget(W); 
  gfx_update_all();
} 

static void new_screen()
{
  Uscreen_t *S;
  S= create_screen();
  S->next= screens;
  screens= screen= S;

  draw_everything();
  edit_pos(S, &S->ident, &S->pos, -1, NULL);
}


static Uscreen_t *create_screen()
{
  char buf[200];
  Uscreen_t *S;
  static int last_scr;
  sprintf(buf,"SCREEN_%d",last_scr++);
  S=calloc(1,sizeof(*S));
  S->ident= strdup(buf);
  return S;
}

static void select_screen()
{
  int N,i,R;
  TUPiis_t *ent;
  Uscreen_t **SS;
 
  SS= get_all_screens(&N);

  ent= calloc(N,sizeof(*ent));

  for(i=0;i<N;i++)
  {
    ent[i].sv= SS[i]->ident;
    ent[i].iv1= i;
    ent[i].iv2= 0;
  }
  R= gfx_fwmenu(2,N,ent);
  free(ent);
  if (R!=-1)
  {
    screen= SS[R];
    draw_everything();
  }
  free(SS);
}

static void edit_screen(Uscreen_t *S)
{
  edit_pos(S,&S->ident,&S->pos,-1,NULL);
}

#line 463 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

static Uscreen_t** get_all_screens(int *Rn)
{
  ptrbuf_t *B;
  Uscreen_t *S,**SS;
  size_t n;

  B= ptrbuf_new(20);
  for(S=screens;S;S=S->next)
   get_sub_screens(B,S);
  ptrbuf_free(B, (void***) &SS, &n);
  *Rn= n;
  return SS;
}

static void get_sub_screens(ptrbuf_t *B, Uscreen_t *S)
{
  Uwidget_t *W;
  int i;

  ptrbuf_put(B, S);
  for(W=S->widgets;W;W=W->next)
   for(i=0;i<W->n_subs;i++)
     get_sub_screens(B, W->subs[i]);
}

static void free_widget(Uwidget_t *w)
{
  free(w);
}
#line 32 "/home/dodo/tmp/GG/gfx-2.2/src/eval.u"

static void get_widget_layout_unknowns
   (Uscreen_t *S,unknown_t ***Runk,size_t *Rnunk)
{
  Uwidget_t *W;
  ptrbuf_t *Bunk;
  Uvar_t *V;

  Bunk= ptrbuf_new(50);

  for(W=S->widgets;W;W=W->next)
  {
    makeref(Bunk, W, wLEF, wRIG, "-", wWID);
    makeref(Bunk, W, wRIG, wLEF, "+", wWID);
    makeref(Bunk, W, wTOP, wBOT, "-", wHEI);
    makeref(Bunk, W, wBOT, wTOP, "+", wHEI);
    makeref(Bunk, W, wWID, wRIG, "-", wLEF);
    makeref(Bunk, W, wHEI, wBOT, "-", wTOP);
  }

  for(V=S->vars;V;V=V->next)
  {
    char buf[200];
    unknown_t *U;
    sprintf(buf,"V%s",V->ident);
    U= calloc(1,sizeof(*U));
    U->target= strdup(buf);
    U->str= V->str;
    U->expr= V->expr; 
    U->source= 'V';
    U->ptr= V;
    U->store= &V->sto;
    ptrbuf_put(Bunk, U);
  }
  ptrbuf_free(Bunk, (void***) Runk, Rnunk);

  copy_fixed_knowns(*Rnunk);
}

static void copy_fixed_knowns(size_t nunk)
{
  int i;
  if (kno) free(kno); 
  kno= malloc(sizeof(*kno)*(nunk + nfixed));
  for(i=0;i<nfixed;i++) kno[i]= fixed[i];
  nkno= nfixed;
}

static char *eval_widget_layout(Uscreen_t *S, size_t *Rnunk, unknown_t ***Runk)
{
  get_widget_layout_unknowns(S,Runk,Rnunk);
  return eval_assignments(NULL,Rnunk, *Runk);
}

static char *eval_assignments(strbuf_t *Bcode,size_t *Rnunk, unknown_t **unk)
{
  int i,change;
  size_t nunk;
  char *R;

  nunk= *Rnunk;

  if (!nunk) return strdup("//NOTHING\n"); 

  if (!Bcode) Bcode= strbuf_init();

  while(nunk)
  {
    change= 0;
    for(i=0;i<nunk;i++)
    {
      //printf("evaluating %s= %s .. ", unk[i]->target,unk[i]->str);
       if (eval_expr(unk[i]->target,unk[i]->expr, Bcode))
       {
         kno[nkno].name= unk[i]->target;
         kno[nkno].sto= unk[i]->store;
         nkno++;
         unk[i]= unk[nunk-1];
         nunk--;
         i--;
         change= 1;
       //printf(" OK\n");
       }
      //else printf("FAIL\n");
    }
    if (!change) break;
  } 

  R= strbuf_collect(Bcode);
  *Rnunk= nunk;
  return R;
}

static int eval_expr(char *target, expr_t *E, strbuf_t *buffer)
{
  int pos;
  pos= strbuf_pos(buffer);
  strbuf_printf(buffer," int %s= ", target);
  if (eval_sub(E,buffer))
  {
    strbuf_reset(buffer,pos);
    return 0;
  }
  strbuf_printf(buffer,";\n");
  return 1;
}

static int eval_sub(expr_t *E, strbuf_t *buffer)
{
  int i;
  switch(E->op)
  {
   case EXP_ADD: return evalbinop(E, buffer, "+");
   case EXP_SUB: return evalbinop(E, buffer, "-");
   case EXP_MUL: return evalbinop(E, buffer, "*");
   case EXP_DIV: return evalbinop(E, buffer, "/");
   case EXP_MOD: return evalbinop(E, buffer, "%");
   case EXP_NEG: return evalpreop(E, buffer, "-");
   case EXP_PLUS: return eval_sub(E->right, buffer);
   case EXP_PAREN_R:
     strbuf_puts(buffer,"(");
     if (eval_sub(E->left,buffer)) return 1;
     strbuf_puts(buffer,")");
     return 0;
   case XPP_FLO:
   case XPP_INT: strbuf_puts(buffer, E->data); return 0;
   case XPP_ERROR: return 1;
   case XPP_IDENT:
     for(i=0;i<nkno;i++)
     {
         if (kno[i].name[0]=='V' && !strcmp(kno[i].name+1,E->data))
         {
            strbuf_puts(buffer,kno[i].name); return 0; 
         }
         if (!strcmp(kno[i].name,E->data)) 
         {
           strbuf_puts(buffer, E->data); return 0; 
         }
     }
     break;
   case EXP_DOT:
     { expr_t *L,*R;
       L= E->left; R= E->right;
       if (L->op!=XPP_IDENT || R->op!=XPP_IDENT) return 1;
       Uwidget_t *W;
       W= find_widget(L->data); 
       if (!W) { 
         // fprintf(stderr,"bad widget: %s\n",L->data);
         return 1; 
       }
       for(i=0;i<6;i++) if (!strcmp(R->data,Cnames[i])) break;
       if (i==6) { 
         // fprintf(stderr,"bad field %s\n",R->data); 
         return 1;
       }
       char *Z;
       Z= malloc(2+strlen(W->ident)+1+strlen(R->data)+1);
       sprintf(Z,"CO%s_%s",W->ident,(char*) R->data);
       for(i=0;i<nkno;i++) if (!strcmp(kno[i].name, Z))
            {  strbuf_puts(buffer, Z); free(Z); return 0; }
       free(Z);
       return 1; }
  }
  return 1;
}

static int evalbinop(expr_t *E, strbuf_t *buffer, char *op)
{
  if (eval_sub(E->left, buffer)) return 1;
  strbuf_puts(buffer,op);
  if (eval_sub(E->right, buffer)) return 1;
  return 0;
}


static void makeref
  (ptrbuf_t *B, Uwidget_t *W, int tgt, int s1, char *op, int s2) 
{
  char *str; expr_t* expr; 
  char nb[200];

  expr= W->pos.E[tgt];
  str= W->pos.S[tgt];
  if (!expr)
  {
    str= malloc(strlen(W->ident)*2+2*8+strlen(op)+10);
    sprintf(str,"CO%s_%s%sCO%s_%s",W->ident,Cnames[s1],op,W->ident,Cnames[s2]);
    expr= xpp_run(xpp, str);
    if (!expr || expr->op==XPP_ERROR) 
    {
      // this will never happen. in case it does, I want a very weird
      // but consistent output
      expr= xpp_run(xpp, "0");
    }
  }

  sprintf(nb,"CO%s_%s",W->ident,Cnames[tgt]);
  unknown_t *U;
  U= calloc(1,sizeof(*U));
  U->target= strdup(nb);
  U->expr= expr;
  U->str= str;

  U->source= 'W';
  U->ptr= W;
  U->subsource= tgt;

  switch(tgt)
  {
  case wTOP: U->store= &W->pos.Dy; break;
  case wBOT: U->store= &W->pos.Db; break;
  case wLEF: U->store= &W->pos.Dx; break;
  case wRIG: U->store= &W->pos.Dr; break;
  case wWID: U->store= &W->pos.Dw; break;
  case wHEI: U->store= &W->pos.Dh; break;
  }
  
  ptrbuf_put(B,U);
}

static int evalpreop(expr_t *E, strbuf_t *buffer, char *op)
{
  strbuf_printf(buffer," %s",op);
  return eval_sub(E->left,buffer);
}

#line 270 "/home/dodo/tmp/GG/gfx-2.2/src/eval.u"

static void evaldis_coords(Uscreen_t *S,int sw,int sh)
{
  int i,change;
  unknown_t **unk; size_t nunk;

  f_wid= sw;
  f_hei= sh;

  get_widget_layout_unknowns(S, &unk, &nunk);

  if (!nunk) return ;

  while(nunk)
  {
    change= 0;
    for(i=0;i<nunk;i++)
    {
       if (evaldis_expr(unk[i]->store,unk[i]->expr))
       {
         kno[nkno].name= unk[i]->target;
         kno[nkno].sto= unk[i]->store;
         nkno++;
         unk[i]= unk[nunk-1];
         nunk--;
         i--;
         change= 1;
       }
    }
    if (!change) break;
  } 
  if (unk) free(unk);
}
  

static int evaldis_expr(int *STO, expr_t *E)
{
  double D;
  if (evaldis_sub(E, &D)) return 0;
  if (STO) *STO= D;
  return 1;
}

static int evaldis_sub(expr_t *E, double *RV)
{
  int i;
  switch(E->op)
  {
   case EXP_ADD: return evaldis_binop(E, RV, opADD);
   case EXP_SUB: return evaldis_binop(E, RV, opSUB);
   case EXP_MUL: return evaldis_binop(E, RV, opMUL);
   case EXP_DIV: return evaldis_binop(E, RV, opDIV);
   case EXP_MOD: return evaldis_binop(E, RV, opMOD);
   case EXP_NEG: return evaldis_preop(E, RV, opNEG);
   case EXP_PAREN_R:
   case EXP_PLUS: return evaldis_sub(E->left, RV);
     return 0;
   case XPP_FLO: *RV= strtod(E->data,NULL); return 0;
   case XPP_INT: *RV= atoi(E->data); return 0;
   case XPP_ERROR: return 1;
   case XPP_IDENT:
     for(i=0;i<nkno;i++)
     {
         if (kno[i].name[0]=='V' && !strcmp(kno[i].name+1,E->data))
         {
            *RV= *kno[i].sto;
            return 0;
         }
         if (!strcmp(kno[i].name,E->data)) 
         {
            *RV= *kno[i].sto;
            return 0;
         }
     }
     break;
   case EXP_DOT:
     { expr_t *L,*R;
       L= E->left; R= E->right;
       if (L->op!=XPP_IDENT || R->op!=XPP_IDENT) return 1;
       Uwidget_t *W;
       W= find_widget(L->data);
       if (!W) return 1;
       for(i=0;i<6;i++) if (!strcmp(R->data,Cnames[i])) break;
       if (i==6) return 1;
       char *Z;
       Z= malloc(2+strlen(W->ident)+1+strlen(R->data)+1);
       sprintf(Z,"CO%s_%s",W->ident,(char*) R->data);
       for(i=0;i<nkno;i++) if (!strcmp(kno[i].name, Z))
            {  *RV= *kno[i].sto; free(Z); return 0; }
       free(Z);
       return 1; }
  }
  return 1;
}


static int evaldis_binop(expr_t *E, double *RV, double (*f)(double,double))
{
  double A,B;
  if (evaldis_sub(E->left, &A)) return 1;
  if (evaldis_sub(E->right, &B)) return 1;
  *RV= (*f)(A, B);
  return 0;
}


static int evaldis_preop(expr_t *E, double *RV, double (*f)(double))
{
  double A;
  if (evaldis_sub(E->left, &A)) return 1;
  *RV= (*f)(A);
  return 0;
}

static double opADD(double A,double B) { return A+B; }
static double opSUB(double A,double B) { return A-B; }
static double opMUL(double A,double B) { return A*B; }
static double opDIV(double A,double B) { if (B!=0) return A/B; else return A; }
static double opMOD(double A,double B) { if ((int)B!=0)return (int)A%(int)B;
                                         else return A; }
static double opNEG(double A) { return -A; }


static char *eval_screen_dim(Uscreen_t *S)
{
  ptrbuf_t *Bunk;
  strbuf_t *Bcode;
  size_t nunk; unknown_t **unk;
  char *code;
  int i;

  Bunk= ptrbuf_new(50);

  makeSref(Bunk, S, wLEF, wRIG, "-", wWID);
  makeSref(Bunk, S, wRIG, wLEF, "+", wWID);
  makeSref(Bunk, S, wTOP, wBOT, "-", wHEI);
  makeSref(Bunk, S, wBOT, wTOP, "+", wHEI);
  makeSref(Bunk, S, wWID, wRIG, "-", wLEF);
  makeSref(Bunk, S, wHEI, wBOT, "-", wTOP);

  ptrbuf_free(Bunk, (void***) &unk, &nunk);
  copy_fixed_knowns(nunk);

  Bcode= strbuf_init();
#if 0
  for(i=0;i<6;i++)  
  {
    char buf[50];
    sprintf(buf,"  int CO%s= -1;\n", Cnames[i]);
    strbuf_puts(Bcode, buf);
  }
#endif
  
  code= eval_assignments(Bcode,&nunk, unk);
  if (nunk)
  {
    Bcode= strbuf_init();
    strbuf_puts(Bcode, code);
    free(code);
    for(i=0;i<nunk;i++) 
    { 
      strbuf_printf(Bcode, "int %s= -1;\n", unk[i]->target);
      free_unknown(unk[i]);
    }
    code= strbuf_collect(Bcode);
  }
  if (unk) free(unk);
  return code;
}

static void free_unknown(unknown_t *U)
{
  if (U) free(U);
}


static void makeSref
  (ptrbuf_t *B, Uscreen_t *S, int tgt, int s1, char *op, int s2) 
{
  char *str; expr_t* expr; 
  char nb[200];

  expr= S->pos.E[tgt];
  str= S->pos.S[tgt];
  if (!expr || expr->op==XPP_ERROR)
  {
    str= malloc(2*8+strlen(op)+10);
    sprintf(str,"CO%s%sCO%s",Cnames[s1],op,Cnames[s2]);
    expr= xpp_run(xpp, str);
    if (!expr || expr->op==XPP_ERROR) 
    {
      // this will never happen. in case it does, I want a very weird
      // but consistent output
      expr= xpp_run(xpp, "0");
    }
  }

  sprintf(nb,"CO%s",Cnames[tgt]);
  unknown_t *U;
  U= calloc(1,sizeof(*U));
  U->target= strdup(nb);
  U->expr= expr;
  U->str= str;

  U->source= 'S';
  U->ptr= S;
  ptrbuf_put(B,U);
}

#line 31 "/home/dodo/tmp/GG/gfx-2.2/src/save.u"

static void safield_s(FILE *f, char *name, char *value)
{
  fprintf(f,"%s ",name);
  fstr(f, value, "\n");
}

static void save_screen(Uscreen_t *S,FILE *f)
{
  Uvar_t *V; Uwidget_t *W;
  int i;

  safield_s(f, "SCREEN", S->ident);
  for(i=0;i<6;i++) if (S->pos.S[i]) 
        { fprintf(f,"Sp%d ",i); fstr(f,S->pos.S[i],"\n"); }

  for(V=S->vars;V;V=V->next)
  {
    safield_s(f, "VAR", V->ident);
    safield_s(f, "VALUE", V->str);
    fprintf(f,"TYPE %d\n",V->vartype);
  }

  for(W=S->widgets;W;W=W->next)
  {
    safield_s(f,"WIDGET", W->ident);
    for(i=0;i<6;i++)
      if (W->pos.S[i]) { fprintf(f,"p%d ",i); fstr(f,W->pos.S[i],"\n"); }
    fprintf(f,"DX %d\nDY %d\nDW %d\nDH %d\n", 
         W->pos.Dx, W->pos.Dy, W->pos.Dw, W->pos.Dh);
    safield_s(f,"KLASS",W->klass->ident);

    field_t *A;
    for(A=W->fields;A;A=A->next)
    {
      safield_s(f,"FNAME", A->name);
      safield_s(f,"FVALUE", A->data);
    }
    if (W->n_subs!=0)
    {
      fprintf(f,"SUBS %d\n",W->n_subs);
      for(i=0;i<W->n_subs;i++)
        save_screen(W->subs[i], f);
      fprintf(f,"ENDSUBS\n");
    }
  }
  fprintf(f,"ENDSCREEN\n");
}

static void save_resource(resource_t *R,FILE *f)
{
  int i,j;

  safield_s(f,"RESOURCE",R->ident);
  fprintf(f,"RTYPE %d\nRLENGTH %d\n",R->type, R->length);
  for(i=0;i<R->length;i+=20)
  {
    fprintf(f,"RDATA ");
    for(j=0;j<20 && i+j<R->length;j++)
       fprintf(f,"%c%c", ((R->data[i+j]>>4)&0xf)+'a', (R->data[i+j]&0xf)+'a');
    fprintf(f,"\n");
  }
  fprintf(f,"ENDRESOURCE\n");
}

static void save_file()
{
  FILE *f;
  char *fn;
  Uscreen_t *S;
  resource_t *R;

  fn= gfx_select_file(1,NULL,NULL); 
  if (!fn) return ;
  f= fopen(fn,"w");
  if (!f) return ;
  for(S=screens;S;S=S->next) save_screen(S, f);
  for(R=resources;R;R=R->next) save_resource(R,f);
  fprintf(f,"END\n");
  fclose(f);
}

static void fstr(FILE *f, char *str, char *sfx)
{
  unsigned char *U;
  U= (void*) str;
  while(*U) { fprintf(f,"%c%c", (*U>>4)+'A', (*U&15)+'a'); U++; }
  fprintf(f, "%s",sfx);
}

static int load_file(Uscreen_t **Rscr, resource_t **Rres)
{
  FILE *f;
  enum fot m;
  char *fn;
  char g[2000];
  Uscreen_t *result, **tgt, *S;
  resource_t *res, *R, **Rtgt;
  char *A;

  fn= gfx_select_file(0,NULL,NULL); 
  if (!fn) return 0;

  f= fopen(fn,"r");
  if (!f) return 0;

  tgt= &result;
  result= NULL;

  Rtgt= &res;
  res= NULL;

  while(getcmdline(g,sizeof(g),f))
    switch((m= command(g,&A)))
    {
    case KWORD(SCREEN):
      S= load_screen(Sarg(A),f);
      *tgt= S;
      tgt= &S->next;
      break;
    case KWORD(RESOURCE):
      R= load_resource(Sarg(A),f);
      *Rtgt= R;
      Rtgt= &R->next;
      break;
    default:
    case KWORD(END):
      goto done;
    }
done:

  fclose(f);
  *Rscr= result;
  *Rres= res;
  return 1;
}

static enum fot command(char *g,char **Ra)
{
  static char *verbs[]= {
#define WORD(X) WORD_STR(X),
    FOT_WORDS
#undef WORD
    NULL};
  return spfx(g,verbs,Ra);
}

static int getcmdline(char *g,int sz,FILE *f)
{
  int i;
  if (!fgets(g,sz,f)) return 0;
  
  g[sz-1]= 0;
  for(i=0;g[i];i++) if (g[i]=='\r' || g[i]=='\n') { g[i]=0; break; }
  return 1;
}

static Uscreen_t *load_screen(char *ident,FILE *f)
{
  Uscreen_t *S, *sub;
  char      g[2000];
  Uvar_t    *V,**Vtgt;
  Uwidget_t *W,**Wtgt;
  field_t   *T,**Ttgt;
  char      *KN;
  char      *A;
  enum fot  m;
  int       count;
  int       i;

  S= calloc(1,sizeof(*S));
  S->ident= ident;

  Vtgt= &S->vars; V= NULL;
  Wtgt= &S->widgets; W= NULL;
  Ttgt= NULL; T= NULL;

restart:

  while(getcmdline(g,sizeof(g),f))
    switch((m= command(g,&A)))
    {
    case KWORD(VAR):
      V= calloc(1,sizeof(*V)); *Vtgt= V; Vtgt= &V->next;
      V->ident= Sarg(A);
      break; 
    case KWORD(VALUE):
      V->str= Sarg(A);
      V->expr= xpp_run(xpp, V->str);
      break; 
    case KWORD(TYPE):
      V->vartype= Iarg(A);
      break;
    case KWORD(WIDGET):
      W= calloc(1,sizeof(*W));
      W->ident= Sarg(A);
      *Wtgt= W;
      Wtgt= &W->next;
      Ttgt= &W->fields;
      break;
    case KWORD(p0): case KWORD(p1): case KWORD(p2):
    case KWORD(p3): case KWORD(p4): case KWORD(p5):
       W->pos.S[m-KWORD(p0)]= Sarg(A);
       W->pos.E[m-KWORD(p0)]= xpp_run(xpp, W->pos.S[m-KWORD(p0)]);
       break;
    case KWORD(DX): W->pos.Dx= Iarg(A); break;
    case KWORD(DY): W->pos.Dy= Iarg(A); break;
    case KWORD(DW): W->pos.Dw= Iarg(A); break;
    case KWORD(DH): W->pos.Dh= Iarg(A); break;
    case KWORD(KLASS):
       KN= Sarg(A);
       W->klass= klasses[0];
       for(i=0;i<sizeof(klasses)/sizeof(klasses[0]);i++)
        if (!strcmp(KN, klasses[i]->ident)) { W->klass= klasses[i]; break; }
       break;
    case KWORD(FNAME):
       T= calloc(1,sizeof(*T));
       T->name= Sarg(A);
       *Ttgt= T;
       Ttgt= &T->next;
       break;
    case KWORD(FVALUE):
       T->data= Sarg(A);
       break;
    case KWORD(Sp0): case KWORD(Sp1): case KWORD(Sp2): 
    case KWORD(Sp3): case KWORD(Sp4): case KWORD(Sp5): 
       S->pos.S[m-KWORD(Sp0)]= Sarg(A);
       S->pos.E[m-KWORD(Sp0)]= xpp_run(xpp, S->pos.S[m-KWORD(Sp0)]);
       break;
    case KWORD(END):
    case KWORD(ENDSCREEN):
    case KWORD(ENDSUBS):
    case KWORD(SCREEN):
    case KWORD(RESOURCE):
    case KWORD(ENDRESOURCE):
    case KWORD(RTYPE):
    case KWORD(RLENGTH):
    case KWORD(RDATA):
       goto done;
    case KWORD(SUBS):
       W->n_subs= Iarg(A);
       W->subs= calloc(W->n_subs,sizeof(W->subs[0]));
       count= 0;
       while(getcmdline(g,sizeof(g),f))
         switch((m=command(g,&A)))
         {
           case KWORD(SCREEN):
             sub= load_screen(Sarg(A),f);
             sub->type= 1;
             if (count<W->n_subs) W->subs[count++]= sub;
             break;
           case KWORD(ENDSUBS):
             goto restart;
           default:
             goto done;
         }
       goto done;
       break;
    }
done:
  return S;
}

static resource_t *load_resource(char *ident,FILE *f)
{
  resource_t *R;
  char      g[2000];
  char      *A;
  int       offset;
  int       i;
  int       L;

  R= calloc(1,sizeof(*R));
  R->ident= ident;

  while(getcmdline(g,sizeof(g),f))
    switch(command(g,&A))
    {
    case KWORD(ENDRESOURCE): return R;
    case KWORD(RTYPE): R->type= Iarg(A); break;
    case KWORD(RLENGTH): R->length= Iarg(A); R->data= malloc(R->length);
                         offset= 0; break;
    case KWORD(RDATA):
       if (!R->data) continue;
       L= strlen(A);
       if (L%2) L--;
       for(i=0;i<L;i+=2)
       {
         if (offset>=R->length) break;
         R->data[offset]= ((A[i]-'a')<<4) | (A[i+1]-'a');
         offset++;
       }
       break;
    default:
       goto done;
    }
done:
  return R;
}

static char *Sarg(char *V)
{
  char *R;
  int L;
  int i;
  L= strlen(V);
  R= malloc(L/2+1);
  for(i=0;i<L/2;i++) R[i]= ((V[2*i]-'A')<<4) | (V[2*i+1]-'a');
  R[i]= 0;
  return R;
}

static int Iarg(char *V)
{
  return atoi(V);
}

static int spfx(char *str, char **PF,char **R)
{
  char *K;
  int i;
  int L;
  for(K=str;K[0];K++) if (K[0]==' ') break;
  for(i=0;PF[i];i++)
  {
    L= strlen(PF[i]);
    if (L!=K-str) continue;
    if (!memcmp(str, PF[i],L)) break;
  }
  if (K[0]) K++; 
  *R= K;
  return i;
}
#line 6 "/home/dodo/tmp/GG/gfx-2.2/src/gen.u"

static char *dotless_name(char *str, char *pfx)
{
  char *Z;
  strbuf_t *SB;
  SB= strbuf_init();
  strbuf_puts(SB, pfx);
  strbuf_puts(SB, "_");
  while(1)
  {
    Z= strchr(str,'.');
    if (Z)
    {
      if (Z!=str)
        strbuf_puts_l(SB, str, Z-str);
      strbuf_puts(SB,"_XO_");
      str= Z+1;
      if (!str[0]) break;
    }
    else
    {
      strbuf_puts(SB,str);
      break;
    }
  }
  return strbuf_collect(SB);
}

static char *widget_layout_fname(Uscreen_t *scr)
{
  return dotless_name(scr->ident, "LAYOWID");
}

static char *screen_layout_fname(Uscreen_t *scr)
{
  return dotless_name(scr->ident,"LAYOSCR");
} 

static void gen_widget_layout(Uscreen_t *scr,FILE* f)
{
  char *code;
  size_t nunk;
  unknown_t **unk;
  int N;
  Uwidget_t *W;

  fprintf(f,"static void %s(int WIDTH,int HEIGHT,int *L) {\n",
                  widget_layout_fname(scr));
  code= eval_widget_layout(scr, &nunk, &unk);
  if (nunk)
  { 
     int i;
     fprintf(f,"%s",code);
     fprintf(f,"#error \"there are unknowns, eval this first\"\n");
     for(i=0;i<nunk;i++)
      fprintf(f,"// %s= %s \n", unk[i]->target, unk[i]->str);
     fprintf(f,"}\n");
     return ;
  }
  fprintf(f,"%s",code);
  free(code);

  for(N=0,W=scr->widgets;W;W=W->next,N++)
  {
    fprintf(f, "  L[%d]= CO%s_left; L[%d]= CO%s_top;\n" 
               "  L[%d]= CO%s_width; L[%d]= CO%s_height;\n", 
                     N*4, W->ident, N*4+1, W->ident,
                     N*4+2, W->ident, N*4+3, W->ident);
  }
  fprintf(f,"}\n");
}

static void gen_screen_dim(Uscreen_t *scr, FILE *f)
{
  fprintf(f,"static void %s(int *L,int WIDTH,int HEIGHT) {\n",
                       screen_layout_fname(scr));
  fprintf(f,"%s", eval_screen_dim(scr));
  fprintf(f,"  L[0]= COleft;\n");
  fprintf(f,"  L[1]= COtop;\n");
  fprintf(f,"  L[2]= COwidth;\n");
  fprintf(f,"  L[3]= COheight;\n");
  fprintf(f,"}\n");
}

static void gen_widget_names(FILE *f)
{
  Uscreen_t *scr;
  Uwidget_t *W;
  Uscreen_t **SS; int N;
  int i;
  SS= get_all_screens(&N);

  fprintf(f,"enum { _XX_WIDGETS_START=GFXEV_LAST+GFXRESERVED,\n ");
  fprintf(f," /* WIDGET NAMES BELOW */\n");
  char buf[2000];
  buf[0]= 0;
  for(i=0;i<N;i++)
  {
   scr= SS[i];
   for(W=scr->widgets;W;W=W->next)
   {
     fprintf(f,"  %s%s,\n", W->ident,buf);
     if (W->klass==&klass_pixgrid)
     {
       sprintf(buf,"=%s+GFXEV_LAST",W->ident);
     }
     else buf[0]= 0;
   }
  }
  fprintf(f,"\n _XX_WIDGETS_END };\n");
  free(SS);
}

static void declare_widget_list(Uwidget_t **WL, int n, FILE *f)
{
  int i;
  fprintf(f," static int SWID[]= { ");
  for(i=0;i<n;i++)
    fprintf(f,"    %s,\n", WL[i]->ident);
  fprintf(f,"};\n");
}

static Uwidget_t** get_widget_list_breadthfirst(Uscreen_t *scr,int *Rn)
{
  // It's important to get the list in breadthfirst fashion,
  // this is because we want to calculate the size&pos for the
  // parent widgets first, and then the child widgets. 
  ptrbuf_t *queue;
  ptrbuf_t *result;
  Uwidget_t *W;
  int i;
  size_t Nww; Uwidget_t **ww;
  int nresult; // #widgets in result so far

  result= ptrbuf_new(20); // holds the widgets
  queue= ptrbuf_new(20); // holds the screens
  nresult= 0;

  ptrbuf_put(queue, scr);
  while((scr=ptrbuf_get(queue)))
  {
    scr->windex_start= nresult;
    for(W=scr->widgets;W;W=W->next)
    {
      ptrbuf_put(result, W);
      nresult++;
      scr->windex_end= nresult;
      for(i=0;i<W->n_subs;i++) ptrbuf_put(queue, W->subs[i]);
    }
  }
  ptrbuf_free(queue,NULL,NULL);
  ptrbuf_free(result, (void***) &ww, &Nww);
  *Rn= Nww;
  return ww;
}

static void gen_screen_func(Uscreen_t *scr,FILE *f,int mode)
{
  Uwidget_t *W;
  int i,j;
  Uscreen_t *S;

  Uwidget_t **ww; int Nww; // this is the list of ALL widgets,
                           // including those in the sub widgets.

  fprintf(f,"void gfx_%s()",scr->ident);
  if (mode=='H') { fprintf(f,";\n"); return ; }
  fprintf(f,"{\n");

  ww= get_widget_list_breadthfirst(scr,&Nww);

  declare_widget_list(ww, Nww,f);
  fprintf(f,"  int i;\n");
  fprintf(f,"  int LC[%d]; /*widget coords */\n",Nww*4);
  fprintf(f,"  int LL[4]; /* screen coords */\n");
  fprintf(f,"  %s(LL,x_window_width,x_window_height);\n",
                   screen_layout_fname(scr));
  fprintf(f,"  enter_screen(%d, SWID,LL);\n",Nww);

                          // we create everything here, including
                          // the widgets embedded in panels.
  for(i=0;i<Nww;i++) Gcreate_widget(ww[i],f);
  // FIXED: the widgets need to be positioned according to the
  //        screen dimensions, not window dimensions
  // FIME: remove this comment
  //fprintf(f,"  %s(x_window_width,x_window_height,LC);\n", 
  //             widget_layout_fname(scr));
  fprintf(f,"  %s(LL[2],LL[3],LC);\n", widget_layout_fname(scr));

  // Now we need to layout the subscreens.
  // we do that using the breadth-first widget list, which gives us
  // a breadth-first screen list.
  for(i=0;i<Nww;i++)
  {
    W= ww[i];
    if (!W->n_subs) continue;
    for(j=0;j<W->n_subs;j++)
    {
      S= W->subs[j];
      fprintf(f,"  %s(LC[%d],LC[%d], LC+%d);\n",
               widget_layout_fname(S), 4*i+2, 4*i+3, 4*S->windex_start);
      fprintf(f,"  for(i=%d;i<%d;i++) { LC[4*i]+= LC[%d]; LC[4*i+1]+= LC[%d];}\n",
               S->windex_start, S->windex_end, 4*i, 4*i+1);
    }
  }

  fprintf(f,"  for(i=0;i<%d;i++) { LC[4*i]+= LL[0]; LC[4*i+1]+= LL[1]; }\n",Nww);
  for(i=0;i<Nww;i++) Ginitialmove_widget(ww[i],f,i);
                            // panels: the list of shown widgets depend on
                            // the active subscreen of the panel, so this
                            // will work.
  for(W=scr->widgets;W;W=W->next) Gshow_widget(W,f);
  fprintf(f,"  gfx_update_all();\n");
  fprintf(f,"}\n");
}

static char *replace_suffix(char *str,char *sfx)
{
  int i;
  str= strdup(str);
  for(i=strlen(str)-1;i>0;i--)
     if (str[i]=='.') { strcpy(str+i,sfx); break; }
  return  str;
}

static void gen_screen()
{
  FILE *hdr,*cfi;
  Uscreen_t *S;
  const char *Chdr;
  const char *Ccode;
  int N; Uscreen_t **SS;
  int i;
  char *fn,*hfn;
  static char *cfiles[]= { "C Source File (*.c)", NULL };

  fn= gfx_select_file(1,NULL,cfiles);
  if (!fn) return ;
  hfn= replace_suffix(fn,".h");

  hdr= fopen(hfn,"w");
  cfi= fopen(fn,"w");
  if (!hdr || !cfi) return ;

  if (!getenv("GFXGEN_DBG"))
  {
    get_library_code(&Chdr, &Ccode);
    fwrite(Chdr, 1, strlen(Chdr), hdr);
    Ccode= print_to_mark(Ccode, "/** USER RESOURCES **/", cfi);
    gen_resources(cfi);
    fwrite(Ccode, 1, strlen(Ccode), cfi);
  }

  gen_widget_names(hdr);
  SS= get_all_screens(&N);

  for(i=0;i<N;i++) gen_widget_layout(SS[i], cfi);
  
  for(i=0;i<N;i++)
  {
    S= SS[i];
    if (S->type) continue;
    gen_screen_dim(S,cfi);
    gen_screen_func(S, cfi,'C'); 
    gen_screen_func(S, hdr,'H');
  }
  free(SS);

  fclose(hdr);
  fclose(cfi);
}

#line 293 "/home/dodo/tmp/GG/gfx-2.2/src/gen.u"


static void Gcreate_widget(Uwidget_t *W,FILE *f)
{
  (*W->klass->create)(W,f);
  fprintf(f, "  widgets[%s]->number= %s;\n", W->ident, W->ident);
}

static void Ginitialmove_widget(Uwidget_t *W,FILE *f,int N)
{
  fprintf(f,"  widget_move(widgets[%s], LC[%d], LC[%d],LC[%d],LC[%d]);\n",
        W->ident, N*4,N*4+1,N*4+2,N*4+3);
}

static void Gshow_widget(Uwidget_t *W,FILE *f)
{
    fprintf(f,"  widget_show(widgets[%s], 1);\n", W->ident);
}

static void gen_resources(FILE *f)
{
  resource_t *R;
  for(R=resources;R;R=R->next)
  {
   switch(R->type)
   {
   case TYP_COLORIMG:
    gen_colorimg_resource(f,R);
    break;
   }
  }
}

static void gen_colorimg_resource(FILE *f,resource_t *R)
{
  int i;
  int L;
  fprintf(f,"RES_COLORIMG(%s,\"User resource\")",R->ident);
  L= R->length/4;
  for(i=0;i<L;i++)
  {
    if (i%5==0) fprintf(f,"\n");
    fprintf(f,"0x%08x,", *(uint32_t*) (R->data+4*i));
  }
  fprintf(f,"\nRES_END\n");
}
#line 128 "/home/dodo/tmp/GG/gfx-2.2/src/klasses.u"

static Uklass_t *choose_klass()
{
  int nk,i,R;
  nk= sizeof(klasses)/sizeof(klasses[0]);
  if (!klass_menu)
  {
    klass_menu= malloc(sizeof(*klass_menu)*nk);
    for(i=0;i<nk;i++)
    {
      klass_menu[i].sv= klasses[i]->ident;
      klass_menu[i].iv1= i;
      klass_menu[i].iv2= 0;
    }
  }
  R= gfx_fwmenu(2, nk, klass_menu);
  if (R==-1) return NULL;
  return klasses[R];
}

static void Kcreate_button(Uwidget_t *W, FILE *f)
{
  fprintf(f, "  widgets[%s]= gfx_button(%s, '%s', %s,GFXCLASS_BUTTON);\n",
        W->ident, Cstr(get_field(W,"text", NULL)),
                  get_field(W,"iconpos", "T"),
                  nustr(get_field(W,"icon",NULL))
  );
}

static void Kcreate_toggle(Uwidget_t *W, FILE *f)
{
  fprintf(f, "  widgets[%s]= gfx_button(%s, '%s', %s,GFXCLASS_TOGGLE);\n",
        W->ident, Cstr(get_field(W,"text", NULL)),
                  get_field(W,"iconpos", "T"),
                  nustr(get_field(W,"icon",NULL))
  );
}

static char *get_field(Uwidget_t *W, char *name, char *def)
{
  field_t *F;
  char *D;
  int i;
  Uklass_t *K;

  for(F=W->fields;F;F=F->next)
    if (!strcmp(F->name, name))
    {
      D= F->data;
      if (D && D[0]) return D;
      break;
    }

  K= W->klass;
  for(i=0;i<K->nfields;i++)
    if (!strcmp(K->fields[i].name,name))
    {
      D= K->fields[i].data;
      if (D && D[0]) return D;
      break;
    }

  return def;
}

static char *nustr(char *x)
{
  if (x) return x;
  else return "NULL";
}

static char *Cstr(char *x)
{
  char *R;
  int L;
  int i,j;
  char *legal= " abcdefghijklmnopqrstuvwxyz!@#$%^&*()_+=-[]{};:,./<>?`~"
               "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
  // char *hex= "0123456789abcdef";
  if (!x) return "NULL";
  L= strlen(x);
  R= malloc(4*L+2+1);
  j= 0;
  R[j++]= '"';
  for(i=0;x[i];i++)
   if (strchr(legal,x[i])) R[j++]= x[i];
   else { sprintf(R+j,"\\%03o", *(unsigned char*)(x+i)); j+= 4; }
  R[j++]= '"';
  R[j++]= 0;
  return R;
}

static void Kcreate_label(Uwidget_t *W, FILE *f)
{
  fprintf(f, "  widgets[%s]= gfx_label(%s,%s,%s,'%s',%s);\n", 
             W->ident, 
    get_field(W,"font","1"),
    get_field(W,"fg", "0"),
    get_field(W,"bg", "1"),
    get_field(W,"just","C"),
    Cstr(get_field(W,"text",""))
  );
}

static void Kcreate_radio(Uwidget_t *W, FILE *f)
{
  fprintf(f, "  widgets[%s]= radio_new(%s,%s);\n", 
                W->ident, Cstr(get_field(W,"text","")),
                          get_field(W,"group","-1"));
}

static void Kcreate_checkbox(Uwidget_t *W, FILE *f)
{
  fprintf(f, "  widgets[%s]= checkbox_new(%s);\n", 
                W->ident, Cstr(get_field(W,"text","")));
}

static void Kcreate_scrollbar(Uwidget_t *W,FILE *f)
{
  fprintf(f, "  widgets[%s]= scrollbar_new(%s,%s,%s,%s,1,NULL,NULL);\n",
               W->ident, get_field(W,"vertical","0"),
                         get_field(W,"init_start","0.0"),
                         get_field(W,"init_end","1.0"),
                         get_field(W,"init_step","0.1") );
}

static void Kcreate_panel(Uwidget_t *W, FILE *f)
{
  int i,n;
  Uwidget_t *cw;
  Uscreen_t *S;
  fprintf(f,"  {\n"
            "    panel_t *PP; \n"
            "    widgets[%s]= (widget_t*) (PP= panel_new(%d));\n",
               W->ident,W->n_subs); 
  for(i=0;i<W->n_subs;i++)
  {
    
    fprintf(f,"    static int WL_%d[]= {\n", i);
    S= W->subs[i];
    for(n=0,cw=S->widgets;cw;cw=cw->next,n++) fprintf(f,"    %s,\n", cw->ident);
    fprintf(f,"    };\n");
    fprintf(f,"    PP->subs[%d].n_widgets= %d;\n", i, n);
    fprintf(f,"    PP->subs[%d].widgets= WL_%d;\n", i,i);
  }
  fprintf(f,"  }\n");
}

static void Kcreate_dropdown(Uwidget_t *W,FILE *f)
{
  fprintf(f,"  widgets[%s]= dropdown_new(1);\n",W->ident);
}

static void Kcreate_list(Uwidget_t *W,FILE *f)
{
  fprintf(f,"  widgets[%s]= gfx_list(0,0,1);\n",W->ident);
}

static void Kcreate_pixgrid(Uwidget_t *W,FILE *f)
{
  fprintf(f,"  widgets[%s]= gfx_pixgrid();\n",W->ident);
}

static void Kcreate_textentry(Uwidget_t *W,FILE *f)
{
  fprintf(f,"  widgets[%s]= text_entry_new(%s);\n",W->ident,
                       Cstr(get_field(W,"text","")) );
}

static void Kcreate_canvas(Uwidget_t *W,FILE *f)
{
   fprintf(f,"  widgets[%s]= gui_canvas_new();\n",W->ident);
}
#line 425 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

void make_panel_subs(Uwidget_t *W)
{
  int N,i;
  Uscreen_t **SS;
  Uscreen_t *S;
  char buf[200];

  N= atoi(get_field(W,"n_subs","2"));
  if (N<2) N= 2;

  if (N==W->n_subs) return ;
  
  SS= calloc(1,sizeof(*SS)*N);
  if (W->n_subs)
  {
    for(i=0;i<W->n_subs;i++)
      SS[i]= W->subs[i];
    free(W->subs);
  }
  W->n_subs= N;
  W->subs= SS;

  for(i=0;i<W->n_subs;i++)
  {
    S= W->subs[i];
    if (!S)
    {
      S= calloc(1,sizeof(*S));
      sprintf(buf,"%s.%d", W->ident,i);
      S->ident= strdup(buf);
      S->type= 1;
      W->subs[i]= S;
    }
  }
}

#line 51 "/home/dodo/tmp/GG/gfx-2.2/src/main.u"

int main()
{
  xpp= xpp_new();

  xpp_binary_operator(xpp, "+", EXP_ADD, 50, 'L');
  xpp_binary_operator(xpp, "-", EXP_SUB, 50, 'L');
  xpp_binary_operator(xpp, "*", EXP_MUL, 60, 'L');
  xpp_binary_operator(xpp, "/", EXP_DIV, 60, 'L');
  xpp_binary_operator(xpp, "%", EXP_MOD, 60, 'L');
  xpp_prefix_operator(xpp, "-", EXP_NEG);
  xpp_prefix_operator(xpp, "+", EXP_PLUS);
  // xpp_binary_operator(xpp, "=", EXP_SET, 30, 'R');
  //xpp_binary_operator(xpp, ",", EXP_COMMA, 20, 'R');
  xpp_parenthesis(xpp, "(", ")", EXP_PAREN_R);
  //xpp_postfix_parenthesis(xpp, "(", ")", EXP_FCALL);
  xpp_binary_operator(xpp, ".", EXP_DOT, 200, 'L');


  if (gfx_init(NULL,DISPW,DISPH,"Layout Editor")) return 1;
  gfx_fill_rect(0,0,0,DISPW,DISPH,0xededed);
  make_buttons();
  gfx_fill_rect(0,area_x,area_y,area_w,area_h, 0xffFFff); 
  gfx_update_all();
  screens= screen= create_screen();
  int mode= 0;
  while(1)
  {
    gfx_event_t event;
    if (!gfx_event(NULL,&event)) continue;
    switch(event.type)
    {
    case GFXEV_QUIT: goto done;
    case WI_SAVE: save_file(); break;
    case WI_GEN: gen_screen(); break;
    case WI_LOAD: { Uscreen_t *S; resource_t *R;
                    if (!load_file(&S,&R)) break; 
                    resources= R;
                    screens= screen= S;
                    draw_everything(); 
                    break; }
    case WI_VARS: show_vars(screen,NULL); break;
    case WI_EVAL: evalscr(); break;
    case WI_LAYOUT: { evaldis_coords(screen,800,600);
                      draw_everything(); break; }
    case WI_NEWSCR: new_screen(); break;
    case WI_SELSCR: select_screen(); break;
    case WI_EDISCR: edit_screen(screen); break;
    case WI_RESOURCE: show_resources(); break;
    case WI_WIDGETDEL:
    case WI_WIDGETEDIT:
    case WI_WIDGETNEW: 
    case WI_WIDGETPOS: mode= event.type; break;
    case GFXEV_BUTTON_RELEASE: if (event.button!=1) break;
        if (event.x<area_x || event.y<area_y || event.x>=(area_x+area_w)
              || event.y>=(area_y+area_h)) break;
        if (mode==WI_WIDGETNEW) 
               { gfx_recsel_begin(event.x,event.y, area_x, area_y,
                                         area_w, area_h); mode= -mode; break; }
        if (mode==-WI_WIDGETNEW) {
             int x1,y1,x2,y2;
             Uklass_t *k;
             Uwidget_t *w;
             gfx_recsel_end(GFX_ORDER, &x1,&y1,&x2, &y2);
             k= choose_klass();
             if (k)
             { 
                w= make_widget(k,x1-area_x,y1-area_y,x2-area_x,y2-area_y);
                edit_widgetpos(screen,w,-1);
                edit_attribs(w);
                draw_widget(w); 
             }
             mode= 0; break; }
         if (mode==WI_WIDGETPOS)
         {
           Uwidget_t *w;
           w= find_widget_bydpos(event.x-area_x,event.y-area_y);
           if(w)  { edit_widgetpos(screen,w,-1); draw_widget(w); }
           mode= 0;
           break;
         }
         if (mode==WI_WIDGETEDIT)
         {
           Uwidget_t *w;
           w= find_widget_bydpos(event.x-area_x,event.y-area_y);
           if(w)  { edit_attribs(w); }
           mode= 0;
           break;
         }
         if (mode==WI_WIDGETDEL)
         {
           Uwidget_t *w;
           w= find_widget_bydpos(event.x-area_x,event.y-area_y);
           if(w) 
           {
             Uwidget_t **p;
             for(p=&screen->widgets;*p && *p!=w;p=&((*p)->next))  ;
             if (*p==w) { *p= w->next; free_widget(w); }
             draw_everything();
           }
           mode= 0;
         }
        break;
    }
  }
done:
  return 0;
}

