#line 6 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>
#include "gfx-1_4.h"
#include "ptrbuf.h"
#include "strbuf.h"
#include "expr.h"
#include "widget.h"
#include "main.h"
#include "pngio.h"
#include "show_resources.h"

#define PAD 10

enum { WI_OK= GFXEV_LAST+1, WI_CANCEL, WI_TYPE, WI_ADD,WI_CLO,WI_DEL, 
               WI_VALIS, WI_UPD };

static int elab;


#line 35 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"
static int  klik_index=-1; static resource_t *klik_resource;

#line 118 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

static int ypo[10], xpo[10];
#define DAGy 200
#define DAGx 300
#define DAGw 400
#define DAGh 400
#define BUT_W 80
#define BUT_H 30
#define ENTw  220
#define ENTh  30

#line 158 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

static int lVars, eName, dType;
static int DT_int=TYP_INT, DT_str= TYP_STR, DT_colorimg= TYP_COLORIMG;


#line 44 "show_resources.c"

static int getevent(gfx_event_t *event);
static void mkypo();
static void prt(char *txt, int x,int y);
static void dbut(char *txt, int action, int x,int y);
static void mkscr();
static void vError(char *msg);
static void vclr();
static int load_color_image(char *fn, size_t *Rlen, uint8_t **Rdata);
#line 109 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"


static int getevent(gfx_event_t *event)
{
  while(1)
   if (gfx_event(NULL,event)) return event->type;
}

#line 130 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

static void mkypo()
{
  int i;
  
  ypo[6]= DAGy+DAGh-PAD-BUT_H;
  for(i=5;i>0;i--)
    ypo[i]= ypo[i+1]-PAD-BUT_H;
  ypo[0]= PAD+DAGy;

  xpo[0]= PAD+DAGx;
  xpo[1]= xpo[0]+ PAD+ BUT_W;
  xpo[2]= DAGx+ 120;
  xpo[3]= xpo[1] + PAD+ BUT_W;
  xpo[4]= DAGx+DAGw-PAD-BUT_W;
}

static void prt(char *txt, int x,int y)
{
  gfx_print(0,1,0x00, 0xededed,x,y,txt,NULL,NULL);
}

static void dbut(char *txt, int action, int x,int y)
{
  gfx_button(GFX_UPDATE,x,y,BUT_W,BUT_H, txt,action);
}

#line 164 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

static void mkscr()
{
  gfx_fill_rect(0,DAGx,DAGy,DAGw,DAGh,0xededed);
  gfx_draw_rect(0,DAGx,DAGy,DAGw-2,DAGh-2,0x00);
  mkypo();
  dbut("Delete", WI_DEL, xpo[1], ypo[1]);
  dbut("Add", WI_ADD, xpo[0], ypo[1]);

  dbut("Close", WI_CLO, xpo[4], ypo[5]);
  prt("Name", xpo[0], ypo[2]+4);

  prt("Type", xpo[0], ypo[4]+4);

  eName= gfx_text_entry(xpo[1],ypo[2], ENTw, ENTh, "");
  dType= gfx_dropdown(xpo[1],ypo[4], 100, ENTh, WI_TYPE);

  gfx_dropdown_insert(dType,-1,"Integer", &DT_int);
  gfx_dropdown_insert(dType,-1,"String", &DT_str);
  gfx_dropdown_insert(dType,-1,"Color Image", &DT_colorimg);
  gfx_dropdown_select(dType, 2);

  gfx_focus(eName);
  gfx_show(dType,1);
  gfx_show(eName,1);

  elab= gfx_label(GFX_UPDATE,1,0x00,0xededed, xpo[0], ypo[6], 
                  DAGw-PAD-PAD, BUT_H, "");

  lVars= gfx_list(0,xpo[0],ypo[0],DAGw-PAD-PAD, ypo[1]-ypo[0]-PAD, WI_VALIS);
  resource_t *R;
  for(R=resources;R;R=R->next)
  {
    gfx_list_insert(lVars,-1,R->ident,R,NULL,0,0);
  }
  gfx_show(lVars,1);
}

static void vError(char *msg)
{
  gfx_label_set_text(GFX_UPDATE,elab, msg);
}

static void vclr()
{
  vError("");
}

static int load_color_image(char *fn, size_t *Rlen, uint8_t **Rdata)
{
  char *e;
  unsigned int w,h,*data;
  unsigned int *cdata;
  e= read_png_image(fn,&w,&h,&data);
  if (e) { vError(e); free(e); return 1; } 
  cdata= malloc(sizeof(unsigned int)*(2+w*h));
  cdata[0]= w | (1<<31);
  cdata[1]= h;
  memcpy(cdata+2, data, sizeof(unsigned int)*w*h);
  free(data);
  *Rdata= (void*) cdata;
  *Rlen= (w*h+2)*sizeof(unsigned int);
  return 0;
}

#line 38 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

void show_resources()
{
  int scr;
  char buf[200];
  static int lastvar;
  resource_t *R;
  char *s1;
  int tt;
  static char *image_types[]= { "Portable Network Graphics (*.png)", NULL};
  size_t dlen;
  uint8_t *data;

  scr= gfx_push_screen();
  mkscr();

  gfx_update_all();

  gfx_event_t event;
  while(1)
  {
   if (!gfx_event(NULL,&event)) continue;
   switch(event.type)
   {
   case GFXEV_QUIT:
   case WI_CLO: goto done;
   case WI_VALIS:
      vclr();
      if (klik_index!=-1) gfx_list_select(lVars, klik_index,0);
      klik_index= event.key;
      klik_resource= event.usr;
      gfx_list_select(lVars, klik_index,1);
      break;
   case WI_ADD:
      vclr();
      if (klik_index!=-1) gfx_list_select(lVars, klik_index,0);
      klik_index= -1;
      tt= gfx_dropdown_selected(dType);
      if (tt==TYP_COLORIMG)
      {
        char *fn;
        fn= gfx_select_file(0,NULL, image_types);
        if (!fn) continue;
        if (load_color_image(fn,&dlen,&data)) continue;
      }
      R= calloc(1,sizeof(*R));
      R->length= dlen;
      R->data= data;
      s1= gfx_text_entry_get(eName);
      if (!s1 || !s1[0])
      {
         sprintf(buf,"res%d", lastvar++);
         s1= buf;
      }
      R->ident= strdup(s1);
      R->type= gfx_dropdown_selected(dType);
      R->next= resources;
      resources= R;
      gfx_list_insert(lVars, 0, R->ident, R, NULL,0,0);


      continue;
   }
  }
  
done:
   gfx_restore_screen(scr);
   return ;
}

#line 230 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

char *choose_color_image()
{
  int N,S;
  resource_t *R;
  TUPiis_t *ent;

  for(N=0,R=resources;R;R=R->next)
   if (R->type==TYP_COLORIMG) N++;
  if (!N) return NULL;
  ent= malloc(sizeof(*ent)*N);

  for(N=0,R=resources;R;R=R->next)
   if (R->type==TYP_COLORIMG)
   {
     ent[N].iv1= N; ent[N].iv2=0; ent[N].sv= R->ident; N++;
   }
  S= gfx_fwmenu(1,N,ent);
  free(ent);
  if (S<0 || S>=N) return NULL;

  for(N=0,R=resources;R;R=R->next)
   if (R->type==TYP_COLORIMG)
   {
     if (N==S) return R->ident;
     N++;
   }
  return NULL;
}
#line 33 "/home/dodo/tmp/GG/gfx-2.2/src/show_resources.u"

