typedef struct
      {
  int   type;
  int   x, y;
  int   modifiers;
  int   button;
  int   key;
  char *string;
  void *usr;
  int wide;
  double flo0, flo1;
      }
    gfx_event_t;

enum
{
  GFXEV_BUTTON_PRESS=1, GFXEV_BUTTON_RELEASE,
  GFXEV_KEY_PRESS,      GFXEV_KEY_RELEASE,
  GFXEV_POINTER_MOVE,   
  GFXEV_READY_READ, GFXEV_READY_WRITE, GFXEV_READY_EXCEPT,
  GFXEV_QUIT, GFXEV_LAST,
};

#define GFXEV(X,Y) (((X)<<8)|(GFXEV_##Y))

#define GFXRESERVED 24

/* The event routine returns an event from the queue. It waits a maximum
   of 'msecs' milliseconds for the event. If msecs is zero, it waits
   until an event is received.

   The return value is one if an event is returned. It's zero if the
   return was due to timeout.

   In case of an event, *msecs is updated to reflect the remaining
   wait time.  */

int gfx_event(unsigned int *msecs,gfx_event_t *Revent);

enum
{ 
   GFX_K_PRT=1, 
   GFX_K_BACKSPACE,     GFX_K_TAB,      GFX_K_RETURN, GFX_K_ESCAPE,
   GFX_K_INSERT,        GFX_K_DELETE,   GFX_K_HOME,   GFX_K_END,
   GFX_K_PAGEUP,        GFX_K_PAGEDOWN,
   GFX_K_LEFT,          GFX_K_RIGHT,    GFX_K_DOWN,   GFX_K_UP,
   GFX_K_CONTROL=0x100, GFX_K_SHIFT= 0x200 , GFX_K_ALT= 0x400,
};

int gfx_init(char *name, int width, int height, char *title);
void gfx_close();


void gfx_geometry(unsigned int *W, unsigned int *H);
void gfx_monitor_file(int fd, int ident, int R,int W,int X);
void gfx_stop_monitor_file(int fd,int ident);
void gfx_leave_screen();
void gfx_set_state(int wno, int state);
int  gfx_get_state(int wno);
int  gfx_get_selected(int wno);
void gfx_set_selected(int wno,int sel);
void gfx_set_text(int wno,char *str);
void gfx_set_fgbg(int wno, int fg, int bg);
void gfx_insert(int wno,int pos, char *text,void *user,unsigned int* icon);
void gfx_remove(int wno, int pos, void **Ruser);
char* gfx_get_text(int wno);
void gfx_focus(int wno);
 
   
int gfx_event(unsigned int *msecs,gfx_event_t *Revent);
void gfx_text_data(int font, const char *str, 
                   int *Rw, int *Rh,int *Ra,unsigned char **Rd);
void gfx_scrollbar_set(int wno, double start, double end, double step);
void gfx_pixgrid_attribs(int pg, int *Rshown, unsigned int *Rw, unsigned int *Rh);
void gfx_pixgrid_put(int pg, int x,int y,
                     unsigned int *img, unsigned int iW,unsigned int iH,
                     int src_x, int src_y, 
                     int copy_w, int copy_h);
void gfx_pixgrid_putsimple(int pg, unsigned int *img);
 
int gfx_ask(char *title, char *butstr, char *fmt, ...);
char* gfx_select_file(int mode,char *init,char **types);
void gfx_canvas_setsize(int wno, int new_w, int new_h);
void gfx_canvas_draw_rectangle(int wno,int color, int x,int y,int w,int h);
void gfx_canvas_fill_rectangle(int wno,int color, int x,int y,int w,int h);
void gfx_canvas_recsel_begin(int wno, gfx_event_t *ev);
void gfx_canvas_recsel_end(int wno,int *Rx1, int *Ry1, int *Rx2, int *Ry2);
void gfx_canvas_print(int font, int color, int rot, int x, int y, char *str);
void gfx_canvas_put_graymap
       (int wno, unsigned int color, int dx,int dy, int w, int h,
        unsigned char *source, int sw, int sh, int sx, int sy);
enum { _XX_WIDGETS_START=GFXEV_LAST+GFXRESERVED,
  /* WIDGET NAMES BELOW */
  WGident,
  WGsubs,
  WGlab13,
  WGstep,
  WGlab12,
  WGend,
  WGlab11,
  WGstart,
  WGlab10,
  WGvertical,
  WGlab9,
  WGgroup,
  WGlab8,
  WGcancel,
  WGok,
  WGjust,
  WGfont,
  WGlab7,
  WGlab6,
  WGbg,
  WGfg,
  WGlab5,
  WGlab4,
  WGlab3,
  WGiconSEL,
  WGicon,
  WGiconpos,
  WGtext,
  WGlab2,
  WGlab1,
  WGlab0,
  WGtitle,
  WresLIST,
  WresDELETE,
  WresCLOSE,
  WresNAME,
  WresADD,
  WresLAB0,
  WresUSE,
  WresTITLE,
  WresMESSAGE,
  WvarLIST,
  WvarUPDATE,
  WvarTYPE,
  WvarVALUE,
  WvarNAME,
  WvarDEL,
  WvarADD,
  WvarLAB2,
  WvarLAB1,
  WvarLAB0,
  WvarCLOSE,
  WvarTITLE,
  WsetCANCEL,
  WsetOK,
  WsetHDRbut,
  WsetSRCbut,
  WsetHEIGHT,
  WsetWIDTH,
  WsetHDR,
  WsetSRC,
  WsetLABEL3,
  WsetLABEL2,
  WsetLABEL1,
  WsetLABEL0,
  WsetTITLE,
  WsselCANCEL,
  WsselUSE,
  WsselNEW,
  WsselDEL,
  WsselLIST,
  WsselTITLE,
  WevOK,
  WevLIST,
  WevTITLE,
  WwselCANCEL,
  WwselTOGGLE,
  WwselTEXTENTRY,
  WwselSCROLLBAR,
  WwselRADIO,
  WwselPIXGRID,
  WwselPANEL,
  WwselLIST,
  WwselLABEL,
  WwselDROPDOWN,
  WwselCHECKBOX,
  WwselCANVAS,
  WwselBUTTON,
  WwselTITLE,
  WwpeMESSAGE,
  WwpeCANCEL,
  WwpeOK,
  WwpeWIDTHvb,
  WwpeRIGHTvb,
  WwpeLEFTvb,
  WwpeHEIGHTvb,
  WwpeBOTTOMvb,
  WwpeTOPvb,
  WwpeWIDTH,
  WwpeRIGHT,
  WwpeLEFT,
  WwpeHEIGHT,
  WwpeBOTTOM,
  WwpeTOP,
  WwpeIDENT,
  WwpeTITLE,
  WwpeLAB6,
  WwpeLAB5,
  WwpeLAB4,
  WwpeLAB3,
  WwpeLAB2,
  WwpeLAB1,
  WwpeLAB0,
  WfilSET,
  Wcan,
  Wsta,
  Wres,
  WlayVAR,
  WlayAPP,
  WlayEVA,
  Wlab3,
  WwidPOS,
  WwidEDI,
  WwidDEL,
  WwidNEW,
  Wlab2,
  WfilGEN,
  WfilLOD,
  WfilSAV,
  Wlab1,
  WscrEDI,
  WscrLIS,
  Wlab0,

 _XX_WIDGETS_END };
void gfx_SCRediwid();
void gfx_SCRres();
void gfx_SCRvar();
void gfx_SCRset();
void gfx_SCRselscr();
void gfx_SCReval();
void gfx_SCRwidsel();
void gfx_SCRwidpos();
void gfx_SCREEN_0();
