#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "ptrbuf.h"
#include "strbuf.h"
#include "gfx.h"
#include "expr.h"
#include "widget.h"
#include "show_vars.h"

static Uscreen_t *wscr;
static int  klik_index=-1; 
static Uvar_t *klik_var;
static int DT_none=VAR_NONE, DT_X= VAR_X, DT_Y=VAR_Y, DT_W=VAR_W, DT_H=VAR_H;


static void free_null_set(void *a, void *V, void (*f)(void*))
{
  void **P;
  P= a;
  if (*P) (*f)(*P);
  *P= V;
}

static void free_expr(void *a)
{
  xpp_free_expr(a);
}

static int getevent(gfx_event_t *event)
{
  while(1)
   if (gfx_event(NULL,event)) return event->type;
}

#if 0

static void mkscr(Uscreen_t *screen,Uvar_t *init)
{


  elab= gfx_label(GFX_UPDATE,1,0x00,0xededed, xpo[0], ypo[6], 
                  DAGw-PAD-PAD, BUT_H, "");

  lVars= gfx_list(0,xpo[0],ypo[0],DAGw-PAD-PAD, ypo[1]-ypo[0]-PAD, WI_VALIS);
  Uvar_t *v;
  int n=0;
  gfx_show(lVars,1);
}
#endif

static char *varstr(Uvar_t *v)
{
  char buf[200];
  memset(buf,0,sizeof(buf));
  snprintf(buf, 40, "%s = %s", v->ident, v->str);
  return strdup(buf);
}

static void vError(char *msg)
{
  //gfx_set_text( msg);
}

static void vclr()
{
  vError("");
}

static int check_uniq(Uscreen_t *s,char *str,void *ptr)
{
  Uwidget_t *W;
  Uvar_t *V;
  for(V=s->vars;V;V=V->next)
    if (V!=ptr && !strcmp(V->ident, str)) return 1;
  for(W=s->widgets;W;W=W->next)
    if (W!=ptr && !strcmp(W->ident, str)) return 1;
  return 0;
}

static void update_entries()
{
  gfx_set_selected(WvarLIST, klik_index);
  gfx_set_text(WvarNAME, klik_var->ident);
  gfx_set_text(WvarVALUE, klik_var->str);
  gfx_set_selected(WvarTYPE, klik_var->vartype);
}

void show_vars(Uscreen_t *screen,Uvar_t *init)
{
  int scr;
  char buf[200];
  static int lastvar;
  Uvar_t *v;
  char *s1, *s2; 
  expr_t *e; 
  gfx_event_t event;
  int n;

  gfx_SCRvar();
  wscr= screen;

  gfx_insert(WvarTYPE,-1,"None", &DT_none,NULL);
  gfx_insert(WvarTYPE,-1,"X", &DT_X,NULL);
  gfx_insert(WvarTYPE,-1,"Y", &DT_Y,NULL);
  gfx_insert(WvarTYPE,-1,"W", &DT_W,NULL);
  gfx_insert(WvarTYPE,-1,"H", &DT_H,NULL);
  gfx_set_selected(WvarTYPE, 0);

  gfx_focus(WvarNAME);

  n= 0;
  for(v= screen->vars;v;v=v->next)
  {
    gfx_insert(WvarLIST,-1,varstr(v),v,NULL);
    if (v==init)
    {
      klik_index= n;
      klik_var= v;
      update_entries();
    }
    n++;
  }

  while(1)
  {
   if (!gfx_event(NULL,&event)) continue;
again:
   switch(event.type)
   {
   case GFXEV_QUIT:
   case WvarCLOSE: goto done;
   case WvarLIST:
      vclr();
      klik_index= event.key;
      klik_var= event.usr;
      update_entries();
      break;
   case WvarUPDATE: 
      vclr();
      s1= gfx_get_text(WvarNAME);
      if (check_uniq(wscr, s1, klik_var)) 
        { vError("Another widget/variable already exists with the same name");
          free(s1); continue; }
      s2= gfx_get_text(WvarVALUE);
      e= xpp_run(xpp,s2);
      if (!e) { vError("Invalid expression"); free(s1); free(s2); continue; }
      if (e->op==XPP_ERROR) { vError(e->data); free(s1); free(s2); continue; }
      klik_var->ident= s1;
      klik_var->str= s2;
      klik_var->expr= e;
      klik_var->vartype= gfx_get_selected(WvarTYPE);
      gfx_remove(WvarLIST, klik_index,NULL);
      gfx_insert(WvarLIST, klik_index,varstr(klik_var),klik_var,NULL); 
      break;
   case WvarADD:
      vclr();
      klik_index= -1;
      v= calloc(1,sizeof(*v));
      sprintf(buf,"var%d", lastvar++);
      v->ident= strdup(buf);
      v->str= "0";
      v->expr= xpp_run(xpp, v->str);
      v->vartype= VAR_NONE;
      v->next= screen->vars;
      screen->vars= v;
      gfx_insert(WvarLIST, 0, varstr(v), v, NULL);
      event.type= WvarLIST;
      event.usr= v;
      event.key= 0;
      goto again;
   }
  }
  
done:
  gfx_leave_screen();
}

 
