
enum { TYP_INT, TYP_STR, TYP_COLORIMG, TYP_LIST };

enum { wTOP, wBOT, wLEF, wRIG, wWID, wHEI };

typedef struct widget Uwidget_t;
typedef struct screen Uscreen_t;

typedef struct
{
  expr_t *E[6];
  char *S[6];
  int Dx,Dy,Dw,Dh; // display x,y,w,h

  int Db,Dr;      // display top and right, used only for
                  // evaluation, never stored or loaded
} Upos_t;

typedef struct field
{
  char *name;
  int type;
  void *data;
  struct field *next;
} field_t;

typedef struct
{
  char *ident;
  int nfields;
  field_t *fields; // these fields contain the default values, if any
  void (*create)(Uwidget_t *,FILE*);
} Uklass_t;


struct widget 
{
  Uklass_t *klass;
  char *ident;
  Upos_t pos;
  field_t *fields; // these contain the user-set values
  struct widget *next;

  int n_subs;
  Uscreen_t **subs;
};

enum { VAR_NONE, VAR_X, VAR_Y, VAR_W, VAR_H };

typedef struct uvar
{
  char *ident;
  char *str;
  expr_t *expr;
  int vartype;
  struct uvar *next;

  int sto;
} Uvar_t;


struct screen
{
  char *ident;
  Uwidget_t *widgets;
  Uvar_t *vars;
  int type; // 0= normal 1= subscreen
  Upos_t pos; // screen position & size
              // should only use WIDTH and HEIGHT..

  /* These are very curious structures. Now, in the library code,
     there is a field called widgets[] in the screen structure.
     Let the library screen be called S, and this subscreen
     be called U. 
        S->widgets[windex_start]= number( firstwidget(U) );
        S->widgets[windex_end]  = number( lastwidget(U) ) + 1;
     So, all widgets of U are recorded between the offsets
     [windex_start,windex_end) within S->widgets. This lets me
     calculate the sub-screen layouts. This is complicated stuff, beh. */
  int windex_start, windex_end;

  struct screen *next;
};

typedef struct
{
  char *target;
  expr_t *expr;
  char *str;
  int source; // 'V' or 'W'
  void *ptr;  // corresponding variable or widget
  int subsource; // in case it's a widget, which coordinate (wTOP etc)

  int *store;
} unknown_t;

typedef struct resource
{
  struct resource *next;
  char *ident;
  int length;
  int type;
  unsigned char *data;
} resource_t;


